/*
	Description:
		* Nintendo Mod Includes

	Written By Soloist
	Version 1.1
	Last Updated On 08/26/06

	*************************************************************************************

	Changelog
		Version 1.1
			* Fixed Nintendo_SetArmor
		Version 1.0
			* Release of the plugin
*/

#define CLASS_NONE 0
#define MAXCHARS 20

// Natives
native Nintendo_RegisterChar(charName[], passive[], skill1[], skill2[], skill3[], powerup[], init[]);
native Nintendo_RegisterHelp(charName[], passiveHelp[], skill1Help[], skill2Help[], skill3Help[], powerupHelp[]);
native Nintendo_RegisterKeyDown(charName[], keyDown[]);
native Nintendo_RegisterKeyUp(charName[], keyUp[]);
native Nintendo_GetUserChar(id, class[], len);
native Nintendo_PowerUpUsed(id, powerUpUsed, coolDownTime);
native Nintendo_PowerUpDeny(id, msg[]);
native Nintendo_ExtraDamage(attacker, victim, damage, weaponDescription[], headshot, dmgType = (1<<1), ff = -1);

// Stocks
stock Nintendo_Active()
{
	if(get_cvar_num("sv_nintendomod"))
		return true;

	return false;
}

stock Nintendo_IsValidPlayer(id)
{
	if(!id || !pev_valid(id))
		return 0
	if(!is_user_connected(id) || !is_user_alive(id))
		return 0
	if(get_user_team(id) != 1 && get_user_team(id) != 2)
		return 0

	return 1
}

stock Nintendo_HasChar(id, charName[])
{
	new class[33];

	Nintendo_GetUserChar(id, class, 32);

	if(equali(class, charName))
		return 1;

	return 0;
}

stock Nintendo_TeamKill(victim, attacker)
{
	if(get_cvar_num("mp_friendlyfire"))
		return true;
	else if(!get_cvar_num("mp_friendlyfire") && (get_user_team(attacker) != get_user_team(victim)))
		return true;
	else if(!get_cvar_num("mp_friendlyfire") && (get_user_team(attacker) == get_user_team(victim)))
		return false;

	return true;
}

stock Nintendo_SetArmor(id, Float:armor)
{
	set_pev(id, pev_armorvalue, armor);
}
stock Nintendo_SetGravity(id, Float:grav)
{
	set_pev(id, pev_gravity, grav / get_cvar_num("sv_gravity"));
}

stock Nintendo_SetHealth(id, Float:health, bool:setMax)
{
	set_pev(id, pev_health, health)
	if(setMax)
		set_pev(id, pev_max_health, health)
}

stock Nintendo_SetSpeed(id, Float:speed)
{
	set_pev(id, pev_maxspeed, speed);
}

stock Nintendo_StatusHUD(id, message[])
{
	set_hudmessage(255, 208, 0, -1.0, 0.25, 0, 6.0, 2.0, 0.1, 0.5, 1)
	show_hudmessage(id, message)
}

stock Nintendo_FindTarget(id, const arg[])
{
	if(!Nintendo_Active() || !is_user_connected(id))
		return PLUGIN_HANDLED;

	new player = find_player("bl", arg)
	if(player)
	{
		if (player != find_player("blj", arg))
		{
			console_print(id, "There are more clients matching to your argument")
			return PLUGIN_CONTINUE;
		}
	}
	else if((player = find_player("c", arg) )==0 && arg[0]=='#' && arg[1])
		player = find_player("k", str_to_num(arg[1]))

	if(!player)
	{
		console_print(id, "Client with that name or userid not found")
		return PLUGIN_CONTINUE;
	}

	return player
}
